"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var downshift = require("downshift"), React = require("react"), primitives = require("@kodiak-ui/primitives"), kodiakUi = require("kodiak-ui");

function _extends() {
  return (_extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

var Combobox = React.forwardRef((function(_ref, ref) {
  var children = _ref.children, _ref$variantKey = _ref.variantKey, variantKey = void 0 === _ref$variantKey ? "comboboxes" : _ref$variantKey, props = _objectWithoutProperties(_ref, [ "children", "variantKey" ]), baseStyles = React.useMemo((function() {
    return {
      border: "1px solid",
      borderColor: "muted",
      borderRadius: "default",
      position: "relative"
    };
  }), []);
  return React.createElement(primitives.Box, _extends({
    __base: baseStyles,
    ref: ref,
    variantKey: variantKey
  }, props), children);
})), ComboboxLabel = React.forwardRef((function(_ref, ref) {
  var children = _ref.children, _ref$variantKey = _ref.variantKey, variantKey = void 0 === _ref$variantKey ? "comboboxes" : _ref$variantKey, props = _objectWithoutProperties(_ref, [ "children", "variantKey" ]);
  return React.createElement(primitives.Label, _extends({
    ref: ref,
    variantKey: variantKey
  }, props), children);
})), ComboboxInput = React.forwardRef((function(_ref, ref) {
  var _ref$variantKey = _ref.variantKey, variantKey = void 0 === _ref$variantKey ? "inputs" : _ref$variantKey, _ref$placeholder = _ref.placeholder, placeholder = void 0 === _ref$placeholder ? "Start typing..." : _ref$placeholder, props = _objectWithoutProperties(_ref, [ "variantKey", "placeholder" ]);
  return React.createElement(primitives.Input, _extends({
    ref: ref,
    variantKey: variantKey,
    variant: "shadow",
    placeholder: placeholder
  }, props));
})), ComboboxButton = React.forwardRef((function(_ref, ref) {
  var children = _ref.children, _ref$variantKey = _ref.variantKey, variantKey = void 0 === _ref$variantKey ? "comboboxes" : _ref$variantKey, props = _objectWithoutProperties(_ref, [ "children", "variantKey" ]), baseStyles = React.useMemo((function() {
    return {
      bg: "transparent",
      border: "none",
      borderLeft: "1px solid",
      borderColor: "muted",
      borderRadius: "none",
      bottom: 0,
      color: "text",
      px: 4,
      position: "absolute",
      right: 0,
      top: 0
    };
  }), []);
  return React.createElement(primitives.Button, _extends({
    __base: baseStyles,
    ref: ref,
    variantKey: variantKey
  }, props), children);
}));

function base(_ref) {
  var theme = _ref.theme;
  return kodiakUi.css({
    borderRadius: "default",
    boxShadow: "0px 2px 6px rgba(28, 56, 78, 0.25)",
    maxHeight: "180px",
    overflowY: "auto",
    margin: 1,
    minWidth: "150px",
    borderTop: 0,
    background: "white",
    position: "absolute",
    zIndex: 1e3,
    listStyle: "none",
    padding: 0
  })(theme);
}

function variant(_ref2) {
  var variantProp = _ref2.variant, variantKey = _ref2.variantKey, theme = _ref2.theme;
  return kodiakUi._variant({
    variant: variantProp,
    theme: theme,
    variantKey: variantKey
  });
}

var Ul = kodiakUi.styled("ul")({
  boxSizing: "border-box",
  margin: 0,
  minWidth: 0
}, base, variant, kodiakUi.sx), ComboboxMenu = React.forwardRef((function(_ref3, ref) {
  var children = _ref3.children, _ref3$variantKey = _ref3.variantKey, variantKey = void 0 === _ref3$variantKey ? "comboboxes" : _ref3$variantKey, props = _objectWithoutProperties(_ref3, [ "children", "variantKey" ]);
  return React.createElement(Ul, _extends({
    ref: ref,
    variantKey: variantKey
  }, props), children);
}));

function base$1(_ref) {
  var theme = _ref.theme;
  return kodiakUi.css({
    color: "text",
    cursor: "pointer",
    py: 3,
    px: 4,
    transition: "all 0.2s ease-in-out"
  })(theme);
}

function variant$1(_ref2) {
  var variantProp = _ref2.variant, variantKey = _ref2.variantKey, theme = _ref2.theme;
  return kodiakUi._variant({
    variant: variantProp,
    theme: theme,
    variantKey: variantKey
  });
}

var Li = kodiakUi.styled("li")({
  boxSizing: "border-box",
  margin: 0,
  minWidth: 0
}, base$1, variant$1, kodiakUi.sx), ComboboxMenuItem = React.forwardRef((function(_ref3, ref) {
  var children = _ref3.children, _ref3$variantKey = _ref3.variantKey, variantKey = void 0 === _ref3$variantKey ? "comboboxes" : _ref3$variantKey, props = _objectWithoutProperties(_ref3, [ "children", "variantKey" ]);
  return React.createElement(Li, _extends({
    ref: ref,
    variantKey: variantKey
  }, props), children);
}));

Object.defineProperty(exports, "useCombobox", {
  enumerable: !0,
  get: function() {
    return downshift.useCombobox;
  }
}), exports.Combobox = Combobox, exports.ComboboxButton = ComboboxButton, exports.ComboboxInput = ComboboxInput, 
exports.ComboboxLabel = ComboboxLabel, exports.ComboboxMenu = ComboboxMenu, exports.ComboboxMenuItem = ComboboxMenuItem;
